%define anolis_release 2

%if %{python3_pkgversion} != 3
%global _pathfix pathfix%{python3_version}.py
%else
%global _pathfix %{__python3} %{_rpmconfigdir}/redhat/pathfix.py
%endif

%global _description \
future is the missing compatibility layer between Python 2 and \
Python 3. It allows you to use a single, clean Python 3.x-compatible \
codebase to support both Python 2 and Python 3 with minimal overhead. \
\
It provides ``future`` and ``past`` packages with backports and forward \
ports of features from Python 3 and 2. It also comes with ``futurize`` and \
``pasteurize``, customized 2to3-based scripts that helps you to convert \
either Py2 or Py3 code easily to support both Python 2 and 3 in a single \
clean Py3-style codebase, module by module.

Name: future
Summary: Easy, clean, reliable Python 2/3 compatibility
Version: 0.18.3
Release: %{anolis_release}%{dist}

License: MIT
URL: http://python-future.org/
Source0: https://github.com/PythonCharmers/python-future/archive/refs/tags/v%{version}/python-%{name}-%{version}.tar.gz
BuildArch: noarch

# https://github.com/PythonCharmers/python-future/issues/165
Patch0001: 0001-future-skip_tests_with_connection_errors.patch

Patch0002: 0002-future-fix_tests.patch

# https://docs.python.org/3.11/whatsnew/3.11.html
Patch0003: 0003-future-python311.patch

# https://github.com/PythonCharmers/python-future/pull/619
Patch0004: 0004-Adjust-tests-to-the-changes-in-Python-3.12.patch

%description
%{_description}

%package -n python%{python3_pkgversion}-%{name}
Summary: Easy, clean, reliable Python 2/3 compatibility
BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python%{python3_pkgversion}-setuptools
BuildRequires: python%{python3_pkgversion}-numpy
BuildRequires: python%{python3_pkgversion}-requests
BuildRequires: python%{python3_pkgversion}-pytest
Provides:      future-python3 = 0:%{version}-%{release}
Provides:      future = 0:%{version}-%{release}
%py_provides   python3-%{name}

Obsoletes: python2-%{name} < 0:%{version}-%{release}
Obsoletes: %{name}-python2 < 0:%{version}-%{release}
Obsoletes: python34-%{name} < 0:%{version}-%{release}

%description -n python%{python3_pkgversion}-%{name}
%{_description}

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -q -n python-future-%{version}

%patch1 -p1 -b .backup
%patch2 -p1 -b .backup
%if 0%{?python3_version_nodots} >= 311
%patch3 -p1 -b .backup
%patch4 -p1 -b .backup
%endif

%build
%py3_build

%install
%py3_install
mv $RPM_BUILD_ROOT%{_bindir}/futurize $RPM_BUILD_ROOT%{_bindir}/futurize-%{python3_version}
mv $RPM_BUILD_ROOT%{_bindir}/pasteurize $RPM_BUILD_ROOT%{_bindir}/pasteurize-%{python3_version}
ln -sf ./futurize-%{python3_version} $RPM_BUILD_ROOT%{_bindir}/futurize-3
ln -sf ./pasteurize-%{python3_version} $RPM_BUILD_ROOT%{_bindir}/pasteurize-3
ln -sf ./futurize-%{python3_version} $RPM_BUILD_ROOT%{_bindir}/futurize
ln -sf ./pasteurize-%{python3_version} $RPM_BUILD_ROOT%{_bindir}/pasteurize
sed -i -e '/^#!\//, 1d' $RPM_BUILD_ROOT%{python3_sitelib}/future/backports/test/pystone.py
chmod a+x $RPM_BUILD_ROOT%{python3_sitelib}/future/backports/test/pystone.py

## This packages ships PEM certificates in future/backports/test directory.
## It's for testing purpose, i guess. Ignore them.
%check
# Bugs
# https://github.com/PythonCharmers/python-future/issues/508
%if 0%{?python3_version_nodots} > 37
PYTHONPATH=$PWD/build/lib py.test-%{python3_version} -k "not test_urllibnet and not test_single_exception_stacktrace" -q
%endif
%if 0%{?python3_version_nodots} <= 37
PYTHONPATH=$PWD/build/lib py.test-%{python3_version}
%endif

%files -n python%{python3_pkgversion}-%{name}
%license LICENSE.txt
%{_bindir}/futurize-3
%{_bindir}/pasteurize-3
%{_bindir}/futurize
%{_bindir}/pasteurize
%{_bindir}/futurize-%{python3_version}
%{_bindir}/pasteurize-%{python3_version}
%{python3_sitelib}/future/
%{python3_sitelib}/past/
%{python3_sitelib}/libfuturize/
%{python3_sitelib}/libpasteurize/
%{python3_sitelib}/*.egg-info

%files doc
%doc README.rst

%changelog
* Tue Mar 12 2024 Bo Ren <rb01097748@alibaba-inc.com> - 0.18.3-2
- Rebuild with python3.11
- Adjust tests to fix build error

* Wed Mar 22 2023 yuanhui <yuanhui@linux.alibaba.com> - 0.18.3-1
- Init package from upstream
